//      ( )

#include<stdio.h>
#include<string.h>
#include<assert.h>

typedef unsigned char BYTE;
typedef unsigned long MASK; //  
#define BITS 32				//    
#define K 2					//  

// 
const char text[]="------abxyab-----abxab--------";
// 
const char pattern[]="abxab";

int len;		//  
MASK mask[256]; //   
MASK S[K+1];	//   




//   ( )
bool Init()
{
	int n; 
	len=strlen(pattern); 
	assert(len>0 && len<BITS);
	for(n=0; n<256; n++) mask[n]=(1<<len)-1;	//    
	for(n=0; pattern[n]; n++) mask[(BYTE)pattern[n]]^=1<<(len-n-1);	//   
	return false;
}

//    
void Show(int pos)
{
	assert(pos>=0 && pos<=strlen(text)-strlen(pattern));
	printf("%s\n",text);
	printf("%*s%s\n",pos,"",pattern);
}

//  


void Work()
{
	MASK t1,t2;
	int index,layer;
	for(layer=0; layer<=K; layer++) S[layer]=(1<<len)-1;	//  
	for(index=0; text[index]; index++) {	// 
		t1=S[0];
		S[0]=(S[0]>>1)|mask[text[index]];	//   
		for(layer=1; layer<=K; layer++) {	//   
			t2=S[layer];
			S[layer]=t1&(S[layer-1]>>1)&(t1>>1)&((S[layer]>>1)|mask[text[index]]);
			t1=t2;
		}
		if(!(S[K]&1)) Show(index-len+1);
	}
	printf("[done]\n");
}


void main()
{
	if(Init()) return;
	Work();
	getchar();
}


